Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.257
diff -u -r1.257 pbx.c
--- pbx.c	8 Jul 2005 21:14:34 -0000	1.257
+++ pbx.c	10 Jul 2005 21:39:39 -0000
@@ -1128,6 +1128,16 @@
 	return 0;
 }
 
+/* returns the size of a GUI string */
+static const char *gui_string(const char *s)
+{
+	return (s ? s : "Not available");
+}
+static int gui_size(const char *s)
+{
+	return 23 + gui_size(s);
+}
+
 static int handle_show_function(int fd, int argc, char *argv[])
 {
 	struct ast_custom_function *acf;
@@ -1145,22 +1155,13 @@
 
 	}
 
-	if (acf->synopsis)
-		synopsis_size = strlen(acf->synopsis) + 23;
-	else
-		synopsis_size = strlen("Not available") + 23;
+	synopsis_size = gui_size(acf->synopsis);
 	synopsis = alloca(synopsis_size);
 	
-	if (acf->desc)
-		description_size = strlen(acf->desc) + 23;
-	else
-		description_size = strlen("Not available") + 23;
+	description_size = gui_size(acf->desc);
 	description = alloca(description_size);
 
-	if (acf->syntax)
-		syntax_size = strlen(acf->syntax) + 23;
-	else
-		syntax_size = strlen("Not available") + 23;
+	syntax_size = gui_size(acf->syntax);
 	syntax = alloca(syntax_size);
 
 	snprintf(info, 64 + AST_MAX_APP, "\n  -= Info about function '%s' =- \n\n", acf->name);
@@ -1168,15 +1169,9 @@
 	term_color(stxtitle, "[Syntax]\n", COLOR_MAGENTA, 0, 40);
 	term_color(syntitle, "[Synopsis]\n", COLOR_MAGENTA, 0, 40);
 	term_color(destitle, "[Description]\n", COLOR_MAGENTA, 0, 40);
-	term_color(syntax,
-		   acf->syntax ? acf->syntax : "Not available",
-		   COLOR_CYAN, 0, syntax_size);
-	term_color(synopsis,
-		   acf->synopsis ? acf->synopsis : "Not available",
-		   COLOR_CYAN, 0, synopsis_size);
-	term_color(description,
-		   acf->desc ? acf->desc : "Not available",
-		   COLOR_CYAN, 0, description_size);
+	term_color(syntax, gui_string(acf->syntax), COLOR_CYAN, 0, syntax_size);
+	term_color(synopsis, gui_string(acf->synopsis), COLOR_CYAN, 0, synopsis_size);
+	term_color(description, gui_string(acf->desc), COLOR_CYAN, 0, description_size);
 	
 	ast_cli(fd,"%s%s%s\n\n%s%s\n\n%s%s\n", infotitle, stxtitle, syntax, syntitle, synopsis, destitle, description);
 
@@ -2952,16 +2947,10 @@
 
 				no_registered_app = 0;
 
-				if (a->synopsis)
-					synopsis_size = strlen(a->synopsis) + 23;
-				else
-					synopsis_size = strlen("Not available") + 23;
+				synopsis_size = gui_size(a->synopsis);
 				synopsis = alloca(synopsis_size);
 
-				if (a->description)
-					description_size = strlen(a->description) + 23;
-				else
-					description_size = strlen("Not available") + 23;
+				description_size = gui_size(a->description);
 				description = alloca(description_size);
 
 				if (synopsis && description) {
@@ -2969,12 +2958,8 @@
 					term_color(infotitle, info, COLOR_MAGENTA, 0, 64 + AST_MAX_APP + 22);
 					term_color(syntitle, "[Synopsis]\n", COLOR_MAGENTA, 0, 40);
 					term_color(destitle, "[Description]\n", COLOR_MAGENTA, 0, 40);
-					term_color(synopsis,
-									a->synopsis ? a->synopsis : "Not available",
-									COLOR_CYAN, 0, synopsis_size);
-					term_color(description,
-									a->description ? a->description : "Not available",
-									COLOR_CYAN, 0, description_size);
+					term_color(synopsis, gui_string(a->synopsis), COLOR_CYAN, 0, synopsis_size);
+					term_color(description, gui_string(a->description), COLOR_CYAN, 0, description_size);
 
 					ast_cli(fd,"%s%s%s\n\n%s%s\n", infotitle, syntitle, synopsis, destitle, description);
 				} else {
@@ -2983,8 +2968,8 @@
 						"[Synopsis]\n  %s\n\n"
 						"[Description]\n%s\n",
 						a->name,
-						a->synopsis ? a->synopsis : "Not available",
-						a->description ? a->description : "Not available");
+						gui_string(a->synopsis),
+						gui_string(a->description));
 				}
 			}
 		}
